import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;

public class Vector<T> 
{
	private List<T> list;
	private Node<T> last;
	private int numValues;

	public Vector() 
	{
		this.list = new List<T>();
		this.last = null;
		this.numValues = 0;
	}
	
	public void add(T x)
	{
		Node<T> pos = null;
		
		if(!this.list.isEmpty())
			pos = this.last;
		
		this.last = this.list.insert(pos, x);
		this.numValues++;
	}
	
	public void del(int place)
	{
		if(place==1)
		{ 
			if(this.last==this.list.getFirst())
				this.last = null;
			this.list.remove(this.list.getFirst());
		}
		else
		{
			Node<T> prev = this.list.getFirst();
			
			for(int i=1; i<=place-2; i++) 
				prev = prev.getNext();
			
			if(this.last==prev.getNext())
				this.last = prev;
			this.list.remove(prev.getNext());
		}
	
		this.numValues--;
	}
	
	public T get(int place)
	{
		Node<T> pos = this.list.getFirst();
		
		for(int i=1; i<=place-1; i++) 
			pos = pos.getNext();
		
		return(pos.getInfo());
	}
	
	public void set(int place, T x)
	{
		Node<T> pos = this.list.getFirst();
		
		for(int i=1; i<=place-1; i++) 
			pos = pos.getNext();
		
		pos.setInfo(x);
	}

	public int length()
	{
		return(this.numValues);
	}
	
	public String toString()
	{
		String str = new String();
		
		if(!this.list.isEmpty())
		{
			Node<T> pos = this.list.getFirst();
		
			while(pos!=this.last)
			{
				str = str + pos.getInfo().toString() + ",";
				pos = pos.getNext();
			}
			str = str + last.getInfo().toString();
		}
		return(str);
	}
}
